#include <iostream.h>
#include <stdio.h>
#include <qgl.h>
#include <GL/gl.h>
#include <Ginit.h>

#include <qevent.h>
#include <qmessagebox.h>

#include "MillGLWidget.h"
#include "Mill.h"
#include "MillWindow.h"

MillGLWidget::MillGLWidget(QWidget *w,Mill *m,QGLFormat &f):QGLWidget(f,w)
{
  mill=m;
  millWindow=(MillWindow*)w;
}

void MillGLWidget::initializeGL() {
  mill->reshapeCB(width(),height());
  mill->init();
  glEnable(GL_TEXTURE_2D);
  glPolygonMode(GL_FRONT,GL_FILL);
  glEnable(GL_FOG);
}

void MillGLWidget::resizeGL( int w, int h ) {
  mill->reshapeCB(w,h);
}

void MillGLWidget::paintGL() {
  mill->draw();
}

void MillGLWidget::mouseMoveEvent(QMouseEvent *e) {
  mill->motionFunc(e->x(),e->y());
  if(mill->mustRedisplay()) {
    mill->draw();
    swapBuffers();
  }
}

void MillGLWidget::mousePressEvent(QMouseEvent *e) {
  int rc=0;
  char text[100];

  if(e->button()==1)
    mill->mouseFunc(GLUT_LEFT_BUTTON,GLUT_DOWN,e->x(),e->y());
  if(e->button()==2) {
    rc=mill->mouseFunc(GLUT_RIGHT_BUTTON,GLUT_DOWN,e->x(),e->y());
  }
  if(mill->mustRedisplay()) {
    mill->draw();
    swapBuffers();
  }

  if(rc) {
    if(rc==1) {
      sprintf(text,"Yellow is the winner");
    } else {
      sprintf(text,"White is the winner");
    }
    QMessageBox *m=new QMessageBox(this,"Mill");
    m->setCaption("Mill");
    m->setText(text);
    m->show();
    millWindow->newGame();
  }
}

void MillGLWidget::mouseReleaseEvent(QMouseEvent *e) {
  if(e->button()==1)
    mill->mouseFunc(GLUT_LEFT_BUTTON,GLUT_UP,e->x(),e->y());
  if(e->button()==2) {
    mill->mouseFunc(GLUT_RIGHT_BUTTON,GLUT_UP,e->x(),e->y());
  }
  if(mill->mustRedisplay()) {
    mill->draw();
    swapBuffers();
  }
}





